{-# LANGUAGE DisambiguateRecordFields #-}
{-# OPTIONS_GHC -Wall -fno-warn-name-shadowing -fno-warn-orphans #-}
module Lam.GUI where

import Lam.Lam
import UI.UI
import qualified Lam.TextRenderer as LamTextRenderer
import Lam.VarsInScope 
import Data.Cursor.CLASE.Persistence
import qualified Data.Map as Map
import Data.Cursor.CLASE.Language
import Lam.Persistence()
import System.Environment

instance UI Lam where
  
  render = LamTextRenderer.render

  renderContextInfo = unlines . 
                      map (uncurry (\i s -> s ++ "(" ++ (show i) ++ ")")) .  Map.toList . varsInScope


instance PersistenceAdapter Lam where
  showL = show
  parseL = readParser False

main :: IO ()
main = do
  args <- getArgs

  initUI $ case args of
                     [fp] -> (Right fp) 
                     _    -> (Left sampleCursor)

sampleCursor :: Cursor Lam Lam Lam
sampleCursor = Cursor {
      it = Lam $ (Abs "x" (Unit `Arr` Unit) $ (Var 0) `App` (Abs "y" Unit $ (Var 0) `App` (Var 1))),
      ctx = Stop,
      log = Route Stop Stop
    }
